//#define _DEBUG

#include <FUTABA_SBUS.h>
#include <Servo.h> 

#ifdef _DEBUG
#include <SoftwareSerial.h>
SoftwareSerial mserial(3, 2); // RX, TX
#endif

FUTABA_SBUS sBus;
Servo FrSkyServo[16];
//------------------------------------------------------------
void setup()
{
#ifdef _DEBUG 
  mserial.begin(115200);
#endif  

 sBus.begin(952,2048);
 FrSkyServo[ 0].attach(4);
 FrSkyServo[ 1].attach(5);
 FrSkyServo[ 2].attach(6);
 FrSkyServo[ 3].attach(7);
 FrSkyServo[ 4].attach(8);
 FrSkyServo[ 5].attach(9);
 FrSkyServo[ 6].attach(10);
 FrSkyServo[ 7].attach(11);
 FrSkyServo[ 8].attach(12);
 FrSkyServo[ 9].attach(13);
 FrSkyServo[10].attach(A0);
 FrSkyServo[11].attach(A1);
 FrSkyServo[12].attach(A2);
 FrSkyServo[13].attach(A3);
 FrSkyServo[14].attach(A4);
 FrSkyServo[15].attach(A5); 
}
//------------------------------------------------------
void loop()
{

  sBus.FeedLine();
  if (sBus.toChannels == 1){
    sBus.UpdateServos();
    sBus.UpdateChannels();
    sBus.toChannels = 0;
    for(byte i=0; i<16 ;i++)
    {
#ifdef _DEBUG      
      mserial.print(i);
      mserial.print(": ");
      mserial.print(sBus.channels[i],DEC);
      mserial.print(" ");
#endif      
      FrSkyServo[i].write(sBus.channels[i]);
    }
#ifdef _DEBUG    
    mserial.println(""); 
#endif    
  }
}
